#!/usr/bin/python
#encoding:utf-8

import os
import sys
import io

print('start transpile')
shaderPath = sys.argv[1]
print('shader路径' + shaderPath)

def alter(file, old_str, new_str):
    """
    替换文件中的字符串
    :param file:文件名
    :param old_str:旧字符串
    :param new_str:新字符串
    :return:
    """
    file_data = ""
    with io.open(file, "r", encoding="utf-8") as f:
        for line in f:
            if old_str in line:
                line = line.replace(old_str,new_str)
            file_data += line
    with io.open(file,"w",encoding="utf-8") as f:
        f.write(file_data)

def process_dir(input_path):
    dir_files = os.listdir(input_path)  # 得到该文件夹下所有的文件
    for file in dir_files:
        file_path = os.path.join(input_path, file)  # 路径拼接成绝对路径
        if os.path.isfile(file_path):  # 如果是文件，就打印这个文件路径
            if file_path.endswith(".vs") or file_path.endswith(".fs"):
                print("transpile " + file_path)
                alter(file_path, "#version 300 es", "#version 310 es")
                alter(file_path, "out vec2 vTexCoord", "layout(location = 0) out vec2 vTexCoord")
                alter(file_path, "in vec2 vTexCoord", "layout(location = 0) in vec2 vTexCoord")
                alter(file_path, "out vec2 vSrcCoord", "layout(location = 1) out vec2 vSrcCoord")
                alter(file_path, "in vec2 vSrcCoord", "layout(location = 1) in vec2 vSrcCoord")
        elif os.path.isdir(file_path):  # 如果目录，就递归子目录
            process_dir(file_path)

if __name__ == '__main__':
    process_dir(shaderPath)